/*
 * Copyright (C) 2014-2016 CERN (www.cern.ch)
 * Author: Federico Vaga <federico.vaga@cern.ch>
 *
 * SPDX-License-Identifier: LGPL-3.0-or-later
 */

#ifndef __LIBTRTL_INTERNAL_H__
#define __LIBTRTL_INTERNAL_H__
#include "libmockturtle.h"

/**
 * Maximum size for device name
 */
#define TRTL_NAME_LEN 16

/**
 * Maximum size for device path
 */
#define TRTL_PATH_LEN 64

/**
 * Internal descriptor for a TRTL device
 */
struct trtl_desc {
	uint32_t devid; /**< device instance identifier */
	uint32_t seq; /**< global sequence number for messages sent from
			 this instance*/
	char name[TRTL_NAME_LEN]; /**< Name of the device */
	char path[TRTL_PATH_LEN]; /**< path to device */
	int fd_dev; /**< File Descriptor of the device */
	int fd_cpu[TRTL_MAX_CPU];  /**< File Descriptor of the CPUs */
	int fd_hmq[TRTL_MAX_CPU][TRTL_MAX_MQ_CHAN]; /**< File Descriptors for the HMQ */
	struct trtl_config_rom cfgrom;/**< synthesis configuration */

	struct trtl_dev *trtl_sync; /**< token for synchronous operations */
};

#endif
